#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <socket.h>
#include <String.h>

static void writeShort(FILE *out,int v) {
  putc(v>>8,out);
  putc(v,out);
}

static void writeUTF(FILE *out,const String &s) {
  int len = s.length();
  writeShort(out,len);
  const char *p = s.chars();
  for (int i = 0; i < len; ++i) {
    putc(p[i]&0x7f,out);
  }
}

int main(int argc,char **argv) {
  int rc = 0;
  char buf[512];
  getcwd(buf,sizeof buf);
  String cwd(buf);
  Socket server;
  if (server.connect("bmsaix.bmsi.com",2009)) {
    perror("bmsaix.bmsi.com:2009");
    return 1;
  }
  FILE *out = fdopen(server.getfd(),"w");
  writeShort(out,argc - 1);
  for (int i = 1; i < argc; ++i) {
    String s(argv[i]);
    int len = s.length();
    if (len > 5) {
      const char *p = s.chars();
      if (!strcmp(s.chars() + len - 5,".java") && p[0] != '/') {
	s = cwd + '/' + s;
      }
    }
    //fprintf(stderr,"%s\n",s.chars());
    writeUTF(out,s);
  }
  fflush(out);
  FILE *in = fdopen(server.getfd(),"r");
  while (fgets(buf,sizeof buf,in)) {
    if (strncmp(buf,"Exit ",5) == 0) {
      int res = atoi(buf+5);
      if (res > rc)
	rc = res;
      return rc;
    }
    fputs(buf,stdout);
  }
  perror("fgets");
  return 1;
}
